/***************************************************************************
 *   Copyright (C) 2006 by Julien Lemoine, Simon Viennot                   *
 *   lapinot@tuxfamily.org                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SOUSTIRAGE_H
#define SOUSTIRAGE_H

#include "calcul.h"

#include <cstdlib>
#include <map>
#include <vector>

typedef map<plaque, int> tirage;

int taille(const tirage&);

vector<tirage> cree_vect(const tirage&);	//renvoie un vecteur contenant les sous-tirages tris dans un ordre "intressant"

ostream& operator<<(ostream& ostr, const tirage& t);		//affichage d'un tirage
ostream& operator<<(ostream& ostr, const vector<tirage>& v);	//affichage d'un vecteur de tirages

bool est_valable(tirage);		//renvoie true si le tirage est valable (pas trop de plaques de chaque sorte).

typedef vector<int> pseudo_tirage;		//un pseudo-tirage est un choix de 6 nb entiers parmi [0;23]

list<pseudo_tirage> cree_liste_pseudo();	//cre les 134596 pseudo-tirages diffrents

tirage pseudo_en_tirage(pseudo_tirage);		//transforme un pseudo-tirage en tirage

set<tirage> tous_les_tirages();			//cre les 13243 tirages diffrents

int coefficient(tirage);			//indique le coef d'un tirage, ie 2^n o n est le nombre de
						//plaquettes du tirage non doubles et diffrentes de 25,50,75,100

//fonctions utilises dans widgetprincipal.cpp, pour manipuler les plaques
plaque plus_petite_plaque_sup(tirage,plaque);
plaque plus_petite_plaque_inf(tirage,plaque);
plaque augmente_plaque(plaque);
plaque diminue_plaque(plaque);

#endif
